#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <clocale>
#include <iostream>
#include <objbase.h>

using namespace std;

#include <math.h>

#include "..\include\ioctl.h"
#include "..\include\ifc_ldev.h"
#include "..\include\create.h"
#include "..\include\791cmd.h"


ULONG   *fdata, *fdata1;
HANDLE hFile, hMap, hFile1, hMap1;
long fsize,k;

ULONG *data, *data1;
ULONG *sync, *sync1;

ULONG status;
USHORT complete;

HANDLE hThread;
ULONG Tid;


ULONG FIFO = 1024;   //       -    1  128,     128
ULONG IrqStep = 1024;// 
ULONG pages = 128;   // IrqSetp*pages       , 
                      //        128    128 

USHORT multi = 4; // -    ,    

//       L780 783 761  slave PCI,
//    128   32.
//       sync[0]   sync[I_ADC_PCI_COUNT_L791].
//   791 sync        

//      
#pragma optimize ("", off)
ULONG WINAPI ServiceThread(PVOID /*Context*/)
{
   ULONG halfbuffer = IrqStep*pages/2;             //    
   ULONG fl2,fl1 = fl2 = (sync[I_ADC_PCI_COUNT_L791]<=halfbuffer)? 0:1; //  
   ULONG *tmp, *tmp1;
   for(int i=0;i<multi;i++)                        //     
   {
      while(fl2==fl1) fl2=(sync[I_ADC_PCI_COUNT_L791]<=halfbuffer)? 0:1;//    
      tmp=fdata+(halfbuffer*i);                    //    
      tmp1=data+(halfbuffer*fl1);                  //     
      memcpy(tmp,tmp1,halfbuffer*sizeof(ULONG));//    
      fl1=(sync[I_ADC_PCI_COUNT_L791]<=halfbuffer)? 0:1;                //  
      Sleep(0);
   }
   complete=1;                                     //    
  return 0;                                          // 
}
#pragma optimize ("", on)

int main(int argc, char *argv[])
{

ADC_PAR ap;
DAC_PAR dacPar;
PLATA_DESCR_L791 pd;
SLOT_PAR sl;
ULONG tm;
int i;

   setlocale(LC_CTYPE, "");

   if(argc==1)
   {
      cout << "L-791 simple example." << endl;
      cout << "(c) 2010 L-Card." << endl;
      cout << "Usage:" << endl;
      cout << "   client <slot number>" << endl;
      cout << "   <slot number> - 0... (if one board installed - 0);" << endl;
      exit(1);
   }
   if(argc<2)
   {
      cout << "no params - exit!" << endl;
      exit(1);
   }


//  
   cout << "Get IUnknown pointer" << endl;

#ifdef WIN64
   CallCreateInstance("lcomp64.dll");
#else
   CallCreateInstance("lcomp.dll");
#endif


   LUnknown* pIUnknown = CreateInstance(atoi(argv[1])); //     
   if(pIUnknown == NULL) { cout << "CallCreateInstance failed" << endl; return 1; }
   
   cout << "Get IDaqLDevice interface" << endl;
   IDaqLDevice* pI;
   HRESULT hr = pIUnknown->QueryInterface(IID_ILDEV,(void**)&pI);
   if(!SUCCEEDED(hr)) { cout << "Get IDaqLDevice failed" << endl; return 1; }
   cout << "IDaqLDevice get success" << endl;
   cout << "Free IUnknown" << endl;
   pIUnknown->Release();

//  
   cout << "OpenLDevice Handle " << pI->OpenLDevice() << endl;
   //cout << "LoadBios status    " << pI->LoadBios("l780") << endl;          
   cout << "Plata test         " << pI->PlataTest() << endl; //      return 0 -      

   cout << endl << "Slot parameters" << endl;   
   pI->GetSlotParam(&sl);

   cout << "Base    " << hex << sl.Base << endl;
   cout << "BaseL   " << sl.BaseL << endl;
   cout << "Mem     " << sl.Mem << endl;
   cout << "MemL    " << sl.MemL << endl;
   cout << "Type    " << sl.BoardType << endl;
   cout << "DSPType " << sl.DSPType << endl;
   cout << "Irq     " << sl.Irq << endl;

   cout << endl << "Read FLASH" << endl;
   pI->ReadPlataDescr(&pd); //    

   cout << "SerNum       " << pd.SerNum << endl;
   cout << "BrdName      " << pd.BrdName << endl;
   cout << "Rev          " << pd.Rev << endl;
   cout << "DspType      " << pd.DspType << endl;
   cout << "IsDacPresent " << pd.IsDacPresent << endl;
   cout << "Quartz       " << dec << pd.Quartz << endl;


//   


   while(!kbhit())
   {
         ASYNC_PAR pp;
         pp.s_Type = L_ASYNC_ADC_INP;
         pp.Chn[0] = 0;
         pI->IoAsync(&pp);
         cout << "adc " << (USHORT)pp.Data[0] << endl;
   }


   ASYNC_PAR pp;
   pp.s_Type = L_ASYNC_TTL_CFG;
   pp.Mode = 1;
   pI->IoAsync(&pp);

   pp.s_Type = L_ASYNC_TTL_OUT;
   pp.Data[0] = 0xA525;
   pI->IoAsync(&pp);

   pp.s_Type = L_ASYNC_TTL_INP;
   pp.Data[0] = 1;
   pI->IoAsync(&pp);

   cout << "ttl input %X " << pp.Data[0] << endl;  

   cout << "Press any key" << endl;
   _getch();

//          
   ap.t2.s_Type = L_ADC_PARAM;
   ap.t2.AutoInit = 1;
   ap.t2.dRate = 200.0;
   ap.t2.dKadr = 0;

   ap.t2.SynchroType = 0;
   ap.t2.SynchroSrc = 0;

   ap.t2.NCh = 4;
   ap.t2.Chn[0] = 0x0;
   ap.t2.Chn[1] = 0x1;
   ap.t2.Chn[2] = 0x2;
   ap.t2.Chn[3] = 0x3;

   ap.t2.FIFO = FIFO;

   ap.t2.IrqStep = 1024;
   ap.t2.Pages = 64;
   ap.t2.IrqEna = 0;  //   
   ap.t2.AdcEna = 1;  //  
//         OSC_LXXX.TST

   pI->FillDAQparameters(&ap.t2);

   tm = 12000;  //     -    512 
//         128     
   pI->RequestBufferStream(&tm,L_STREAM_ADC);

   cout << "Allocated memory size(word): " << tm << endl;
   pI->SetParametersStream(&ap.t2, &tm, (void**)&data, (void**)&sync,L_STREAM_ADC);

   cout << "Buffer size(points): " << tm << endl;
   cout << "Pages: " << ap.t2.Pages << endl;
   cout << "Rate: " << ap.t2.dRate << endl;

   IrqStep = ap.t2.IrqStep;
   pages = ap.t2.Pages;

//  
//              
   dacPar.t2.s_Type = L_DAC_PARAM;
   dacPar.t2.AutoInit=0;
   dacPar.t2.dRate=10.0;
   dacPar.t2.FIFO=1024;
   dacPar.t2.IrqStep=1024;
   dacPar.t2.Pages=128;
   dacPar.t2.IrqEna=0;
   dacPar.t2.DacEna=1;

   pI->FillDAQparameters(&dacPar.t2);

   ULONG db=512000;
   pI->RequestBufferStream(&db, L_STREAM_DAC);
   pI->SetParametersStream(&dacPar.t2,&db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);

   for(i=0;i<128*1024;i++) data1[i] = ((USHORT)(1024.0*sin((2.0*3.1415*i/1024.0)))&0xFFF) | (1<<12);
///////////

   ULONG param;
   cout << "Test GetParameter" << endl;
   pI->GetParameter(L_BOARD_TYPE, &param);
   cout << "Board Type " << param << endl;
   pI->GetParameter(L_SYNC_ADDR_LO, &param);
   cout << "Board Type " << hex << param << " " << sync << endl;
   pI->GetParameter(L_DATA_ADDR_LO, &param);
   cout << "Board Type " << hex << param << " " << data << endl;



   cout << "Press any key" << endl;
   _getch();

   cout << "Started ..." << endl;
//  
   fsize=multi*(pages/2)*IrqStep; //  

   hFile=CreateFile("data.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                               NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);

   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*sizeof(ULONG),NULL);

   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata=(PULONG)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

   complete=0;

//   pI->EnableCorrection();     

//    
   pI->InitStartLDevice();

//      
   hThread=CreateThread(0,0x2000,ServiceThread,0,0,&Tid);//

   //    
   status=pI->StartLDevice();

   //    
   while(!/*kbhit()*/complete)
   {
      cout << sync[I_ADC_PCI_COUNT_L791] << " "  << sync[I_DAC_PCI_COUNT_L791] << endl;
      Sleep(20);
   }

   cout << "StartLDevice returned " <<  (status ? "TRUE":"FALSE") << endl;

   pI->StopLDevice(); //  


   cout << "Converting ..." << endl;
//  

   hFile1=CreateFile("data1.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                               NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);

   if(hFile1==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap1=CreateFileMapping(hFile1,NULL,PAGE_READWRITE,0,fsize*sizeof(ULONG),NULL);

   if(hMap1==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata1=(PULONG)MapViewOfFile(hMap1,FILE_MAP_WRITE,0,0,0);

   for(k=0;k<fsize;k++) fdata1[k] = (short)(fdata[k]&0xFFFF);


end:

   pI->CloseLDevice();
   pI->Release();

   CloseHandle(hThread);

   UnmapViewOfFile(fdata);
   CloseHandle(hMap);
   CloseHandle(hFile);

   UnmapViewOfFile(fdata1);
   CloseHandle(hMap1);
   CloseHandle(hFile1);

   cout << "Exit" << endl;
   return 0;
}
